
!UiTreeViewport methodsFor: 'add/remove' stamp: 'mt 10/10/2010 10:29:55.411'!
addMorph: aMorph atIndex: aModelIndex

	| col row indent |	
	aMorph setProperty: #modelIndex toValue: aModelIndex.
	aMorph setProperty: #isExpanded toValue: false.
	
	row := self addRowFor: aModelIndex.
	row items add: aMorph.
	
	col := self columnFor: aModelIndex.
	col items add: aMorph beforeIndex: (rows indexOf: row).
	
	self addMorphBack: aMorph.
	
	"Correct indent."
	indent := 0.
	(aModelIndex column = 1) ifTrue: [
		(col itemBefore: aMorph)
			ifNil: [indent := self indent] "root"
			ifNotNil: [:item |
				"The item before is my parent. Add additional indentation."
				(item valueOfProperty: #modelIndex) = aModelIndex parent
					ifTrue: [indent := (item valueOfProperty: #indent) + self indent].
				"The item before is my sibling. Use its indentation."
				(item valueOfProperty: #modelIndex) parent = aModelIndex parent
					ifTrue: [indent := item valueOfProperty: #indent]]].
	aMorph setProperty: #indent toValue: indent.! !

!UiTreeViewport methodsFor: 'drawing' stamp: 'mt 10/8/2010 14:40:52.56'!
drawOn: aCanvas
	
	self drawSelectionOn: aCanvas.
	super drawOn: aCanvas.! !

!UiTreeViewport methodsFor: 'accessing' stamp: 'mt 10/9/2010 19:54:19.441'!
indent

	^ indent ifNil: [indent := 10]! !

!UiSimpleModelIndex methodsFor: 'testing - hierarchy' stamp: 'mt 10/8/2010 13:59:28.388'!
hasChildren

	^ model hasChildren: self! !
